package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLAff extends JNIObject implements IISLSingleSpaceReadOnlyMapMethods {
	
	/* @generated */
	protected ISLAff(long ptr) {
		/*** PROTECTED REGION ID(ISLAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLAff build(long ptr) {
		return new ISLAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*
	 * Most of the code in this protected region is to give 
	 * an API with long instead of ISLVal.
	 */
	
	
	public long getNumerator(ISLDimType dType, int pos) {
		return getCoefficientVal(dType, pos).getNumerator();
	}

	public long getConstant() {
		return getConstantVal().asLong();
	}

	/**
	 * This is the common denominator for the entire qAff expression
	 * 
	 * @return
	 */
	public long getDenominator() {
		return getDenominatorVal().asLong();
	}
	

	public static ISLAff buildValOnDomain(ISLLocalSpace ls, long v) { 
		ISLVal val = ISLVal.buildFromLong(ls.getContext(), v);
		return buildValOnDomain(ls.copy(), val);
	}

	public ISLAff mod(long v) {
		ISLVal val = ISLVal.buildFromLong(getContext(), v);
		return mod(val);
	}
	public ISLAff scale(long v) {
		ISLVal val = ISLVal.buildFromLong(getContext(), v);
		return scale(val);
	}
	
	static boolean lvl0 = true;
	public String javaPrint() {

		boolean is_lvl_0 = lvl0;
		lvl0 = false;

		String javaPrint = "";
		boolean first = true;

		//common denominator
		long commonD = getDenominator();
		
		ISLVal constant = getConstantVal();
		long cst = (constant.getNumerator() * commonD) / constant.getDenominator();
		if (cst != 0) {
			first = false;
			javaPrint += cst;
		}

		ISLSpace dims = this.getSpace();

		ISLDimType dimType = ISLDimType.isl_dim_in;
		int n = dim(dimType);
		for (int i = 0; i < n; i++) {
			ISLVal coefficient = getCoefficientVal(dimType, i);
			long coef = (coefficient.getNumerator() * commonD) / coefficient.getDenominator();
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef);
				String name = dims.getDimName(dimType, i);
				if (name == null)
					name = "i" + i;
				javaPrint += name;
			}
		}

		dimType = ISLDimType.isl_dim_param;
		n = dim(dimType);
		for (int i = 0; i < n; i++) {
			ISLVal coefficient = getCoefficientVal(dimType, i);
			long coef = (coefficient.getNumerator() * commonD) / coefficient.getDenominator();
			
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef);
				String name = dims.getDimName(dimType, i);
				if (name == null)
					name = "p" + i;
				javaPrint += name;
			}
		}

		dimType = ISLDimType.isl_dim_div;
		n = dim(dimType);
		for (int i = 0; i < n; i++) {
			ISLVal coefficient = getCoefficientVal(dimType, i);
			long coef = (coefficient.getNumerator() * commonD) / coefficient.getDenominator();
			
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef) + "*";

				ISLAff div = getDiv(i);
//						javaPrint += "floor[" + div.javaPrint() + "]";
				javaPrint += "floor(" + div.javaPrint() + ")";
			}
		}
		javaPrint = "(" + javaPrint + ")";
		if (commonD != 1)
			javaPrint += "/" + commonD;
		if (javaPrint.length() == 2)
			javaPrint = "[(0)]";
		else {
			if (is_lvl_0) {
				javaPrint = "[" + javaPrint + "]";
			}
		}
		if (is_lvl_0)
			lvl0 = true;
		return javaPrint;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_aff_read_from_str) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_zero_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLAff buildZero(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_aff_zero_on_domain) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLAff.build(ISLNative.isl_aff_zero_on_domain(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_param_on_domain_space_id 
	 * 
	@take space id
	 * @generated
	**/
	 public static ISLAff buildParamOnDomainSpace(ISLSpace space, ISLIdentifier id) { 
		/*** PROTECTED REGION ID(static_isl_aff_param_on_domain_space_id) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(space, id);
			try {
				res = ISLAff.build(ISLNative.isl_aff_param_on_domain_space_id(getNativePtr(space), getNativePtr(id)));
			} finally {
				taken(space);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_val_on_domain 
	 * 
	@take ls val
	 * @generated
	**/
	 public static ISLAff buildValOnDomain(ISLLocalSpace ls, ISLVal val) { 
		/*** PROTECTED REGION ID(static_isl_aff_val_on_domain) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(ls, val);
			try {
				res = ISLAff.build(ISLNative.isl_aff_val_on_domain(getNativePtr(ls), getNativePtr(val)));
			} finally {
				taken(ls);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_var_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLAff buildVarOnDomain(ISLLocalSpace ls, ISLDimType type, int pos) { 
		/*** PROTECTED REGION ID(static_isl_aff_var_on_domain) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLAff.build(ISLNative.isl_aff_var_on_domain(getNativePtr(ls), type.getValue(), pos));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_nan_on_domain 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLAff buildNaNOnDomain(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_aff_nan_on_domain) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLAff.build(ISLNative.isl_aff_nan_on_domain(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLAff aff, int format) { 
		/*** PROTECTED REGION ID(static_isl_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_to_string(getNativePtr(aff), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_multi_aff_from_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff toMultiAff() {
		/*** PROTECTED REGION ID(isl_multi_aff_from_aff) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_from_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff toUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_from_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_equality_from_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLConstraint toEqualityConstraint() {
		/*** PROTECTED REGION ID(isl_equality_from_aff) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLConstraint.build(ISLNative.isl_equality_from_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_inequality_from_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLConstraint toInequalityConstraint() {
		/*** PROTECTED REGION ID(isl_inequality_from_aff) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLConstraint.build(ISLNative.isl_inequality_from_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_local_space 
	 * 
	 * @generated
	**/
	public ISLLocalSpace getLocalSpace() {
		/*** PROTECTED REGION ID(isl_aff_get_local_space) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLLocalSpace.build(ISLNative.isl_aff_get_local_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_copy 
	 * 
	 * @generated
	**/
	public ISLAff copy() {
		/*** PROTECTED REGION ID(isl_aff_copy) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_domain_space 
	 * 
	 * @generated
	**/
	public ISLSpace getDomainSpace() {
		/*** PROTECTED REGION ID(isl_aff_get_domain_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_aff_get_domain_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_domain_local_space 
	 * 
	 * @generated
	**/
	public ISLLocalSpace getDomainLocalSpace() {
		/*** PROTECTED REGION ID(isl_aff_get_domain_local_space) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLLocalSpace.build(ISLNative.isl_aff_get_domain_local_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_aff_align_params) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLAff.build(ISLNative.isl_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_aff_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff insertDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_aff_insert_dims) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_insert_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_aff_add_dims) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_aff_move_dims) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_aff_drop_dims) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_aff_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_aff_set_dim_name) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_constant_val 
	 * 
	 * @generated
	**/
	public ISLVal getConstantVal() {
		/*** PROTECTED REGION ID(isl_aff_get_constant_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_aff_get_constant_val(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_coefficient_val 
	 * 
	 * @generated
	**/
	public ISLVal getCoefficientVal(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_aff_get_coefficient_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_aff_get_coefficient_val(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_denominator_val 
	 * 
	 * @generated
	**/
	public ISLVal getDenominatorVal() {
		/*** PROTECTED REGION ID(isl_aff_get_denominator_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_aff_get_denominator_val(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_set_constant_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff setConstant(int v) {
		/*** PROTECTED REGION ID(isl_aff_set_constant_si) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_set_constant_si(getNativePtr(this), v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_set_constant_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff setConstant(ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_set_constant_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_set_constant_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_set_coefficient_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff setCoefficient(ISLDimType type, int pos, int v) {
		/*** PROTECTED REGION ID(isl_aff_set_coefficient_si) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_set_coefficient_si(getNativePtr(this), type.getValue(), pos, v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_set_coefficient_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff setCoefficient(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_set_coefficient_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_set_coefficient_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_is_cst 
	 * 
	 * @generated
	**/
	public boolean isConstant() {
		/*** PROTECTED REGION ID(isl_aff_is_cst) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_is_cst(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_plain_is_equal(getNativePtr(this), getNativePtr(aff2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_plain_is_zero 
	 * 
	 * @generated
	**/
	public boolean isPlainZero() {
		/*** PROTECTED REGION ID(isl_aff_plain_is_zero) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_plain_is_zero(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_is_nan 
	 * 
	 * @generated
	**/
	public boolean isNaN() {
		/*** PROTECTED REGION ID(isl_aff_is_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_aff_is_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_get_div 
	 * 
	 * @generated
	**/
	public ISLAff getDiv(int pos) {
		/*** PROTECTED REGION ID(isl_aff_get_div) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_aff_get_div(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff negate() {
		/*** PROTECTED REGION ID(isl_aff_neg) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_ceil 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff ceil() {
		/*** PROTECTED REGION ID(isl_aff_ceil) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_ceil(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff floor() {
		/*** PROTECTED REGION ID(isl_aff_floor) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add 
	 * 
	 * @take this aff2
	 * @generated
	**/
	public ISLAff add(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_add) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff2);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add(getNativePtr(this), getNativePtr(aff2)));
			} finally {
				taken(this);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_sub 
	 * 
	 * @take this aff2
	 * @generated
	**/
	public ISLAff sub(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_sub) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff2);
			try {
				res = ISLAff.build(ISLNative.isl_aff_sub(getNativePtr(this), getNativePtr(aff2)));
			} finally {
				taken(this);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_mul 
	 * 
	 * @take this aff2
	 * @generated
	**/
	public ISLAff mul(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_mul) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff2);
			try {
				res = ISLAff.build(ISLNative.isl_aff_mul(getNativePtr(this), getNativePtr(aff2)));
			} finally {
				taken(this);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_div 
	 * 
	 * @take this aff2
	 * @generated
	**/
	public ISLAff div(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_div) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff2);
			try {
				res = ISLAff.build(ISLNative.isl_aff_div(getNativePtr(this), getNativePtr(aff2)));
			} finally {
				taken(this);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_scale_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_mod_val 
	 * 
	 * @take this mod
	 * @generated
	**/
	public ISLAff mod(ISLVal mod) {
		/*** PROTECTED REGION ID(isl_aff_mod_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mod);
			try {
				res = ISLAff.build(ISLNative.isl_aff_mod_val(getNativePtr(this), getNativePtr(mod)));
			} finally {
				taken(this);
				taken(mod);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_scale_down_ui 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff scaleDown(int f) {
		/*** PROTECTED REGION ID(isl_aff_scale_down_ui) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_scale_down_ui(getNativePtr(this), f));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_scale_down_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff scaleDown(ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_scale_down_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_scale_down_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_constant_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff addConstant(int v) {
		/*** PROTECTED REGION ID(isl_aff_add_constant_si) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_constant_si(getNativePtr(this), v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_constant_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff addConstant(ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_add_constant_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_constant_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_constant_num_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff addConstantToNumerator(int v) {
		/*** PROTECTED REGION ID(isl_aff_add_constant_num_si) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_constant_num_si(getNativePtr(this), v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_coefficient_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLAff addCoefficient(ISLDimType type, int pos, int v) {
		/*** PROTECTED REGION ID(isl_aff_add_coefficient_si) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_coefficient_si(getNativePtr(this), type.getValue(), pos, v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_add_coefficient_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLAff addCoefficient(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_aff_add_coefficient_val) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLAff.build(ISLNative.isl_aff_add_coefficient_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLAff gist(ISLSet context) {
		/*** PROTECTED REGION ID(isl_aff_gist) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLAff.build(ISLNative.isl_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLAff gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_aff_gist_params) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLAff.build(ISLNative.isl_aff_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_pullback_aff 
	 * 
	 * @take this aff2
	 * @generated
	**/
	public ISLAff pullback(ISLAff aff2) {
		/*** PROTECTED REGION ID(isl_aff_pullback_aff) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff2);
			try {
				res = ISLAff.build(ISLNative.isl_aff_pullback_aff(getNativePtr(this), getNativePtr(aff2)));
			} finally {
				taken(this);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_pullback_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLAff pullback(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_aff_pullback_multi_aff) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLAff.build(ISLNative.isl_aff_pullback_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_eval 
	 * 
	 * @take this pnt
	 * @generated
	**/
	public ISLVal eval(ISLPoint pnt) {
		/*** PROTECTED REGION ID(isl_aff_eval) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, pnt);
			try {
				res = ISLVal.build(ISLNative.isl_aff_eval(getNativePtr(this), getNativePtr(pnt)));
			} finally {
				taken(this);
				taken(pnt);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
